﻿local Root = BossEncounter3;

local L = Root:GetOrNewModule("Localization");
local Save = Root:GetOrNewModule("Save");

local NPCName = Root:GetOrNewModule("NPCName");

-- --------------------------------------------------------------------
-- **                             Data                               **
-- --------------------------------------------------------------------

-- Service registering names of selectable mobs.

-- --------------------------------------------------------------------
-- **                          Functions                             **
-- --------------------------------------------------------------------

-- ********************************************************************
-- * Arguments:                                                       *
-- * >> mobID: the mob ID (not GUID!).                                *
-- ********************************************************************
-- * Grab name of the specified mob ID.                               *
-- ********************************************************************
function NPCName:Get(mobID)
    return self.DB[mobID];
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * >> mobID: the mob ID (not GUID!).                                *
-- * >> name: the name of the mob.                                    *
-- ********************************************************************
-- * Register the name of an NPC, so it can be requeried later.       *
-- ********************************************************************
function NPCName:Register(mobID, name)
    self.DB[mobID] = name;
end

-- --------------------------------------------------------------------
-- **                             Handlers                           **
-- --------------------------------------------------------------------

function NPCName:OnBootComplete()
    -- Grab the DB table.
    self.DB = Save:Get("npcNames", L:GetLocale()) or { };
    Save:Set("npcNames", L:GetLocale(), self.DB);
end
