﻿local Root = BossEncounter3;

local Localization = Root:GetOrNewModule("Localization");

local MISSING_TRANSLATION = "%s";

-- Test command
local overrideLocale = nil;
--overrideLocale = "enUS";

-- --------------------------------------------------------------------
-- **                             Data                               **
-- --------------------------------------------------------------------

local redirection = { -- Do not change this.
    ["enGB"] = "enUS",
    ["esMX"] = "esES",
};

local locale = {
    ["enUS"] = {
        ["HP"] = "HP",
        ["Ad"] = "Powered by BossEncounter3",
        ["Anchor"] = "Anchor point",
        ["DefaultPosition"] = "Use default position",
        ["Lock"] = "Lock position",
        ["Size"] = "Resize",
        ["Top"] = "Top",
        ["Center"] = "Center",
        ["Bottom"] = "Bottom",

        ["BootComplete"] = "Loaded (v%s, %d music plugins).\n/BE3 (or /BE) to access slash commands.",
        ["FirstTimeNotice"] = "You are running %s version of BossEncounter3 for the first time.\n\nUse |cff808080/BE3|r to access commands.\nYou should also take a look at /BE3 options.\n\nPlease type the grey word to close this pop-up window.",
        ["SaveReformat"] = "Changes in the system required to erase your saved data.",
        ["NoAdminIgnore"] = "You can't ignore an internal BE3 administrator.",
        ["IncompleteFight"] = "Incomplete fight",
        ["IncompleteFightExplain"] = "You got an |cffff0000\"incomplete fight\"|r. This occurs when the boss module is enabled after the boss has been engaged. Select each boss before pulls to avoid this.",
        ["CoupDeGrace"] = "Coup De Grâce!",
        ["Try"] = "Attempt %d",
        ["Failure"] = "Failure",
        ["Expiration"] = "Expired",
        ["Defeated"] = "[%s] has been defeated in %d attempt(s)!",
        ["FightTime"] = "Fight time: %s",
        ["TimeRecord"] = "Previous best time: %s",
        ["NoSequenceReplay"] = "No victory sequence to replay: you haven't cleared any boss during this game session.",
        ["NoDpsData"] = "No damage data available: you haven't cleared any boss during this game session.",
        ["NoActiveModule"] = "No module is running.",
        ["DifficultySet"] = "Difficulty level set to [%s] (%d).",
        ["InvalidDifficulty"] = "Specified invalid difficulty level.",
        ["ThresholdShort"] = "%s soon.",
        ["ThresholdFull"] = "%s at %d%%.",
        ["TestAlert"] = "Test alert",
        ["TestMessage"] = "Test message",
        ["TestEnabled"] = "Test mode enabled. Retype test to disable the test mode.",
        ["TestDisabled"] = "Test mode disabled.",
        ["CaptureSample"] = "There are %d samples for encounter [%s].",
        ["HealRangeInvalid"] = "Please set healers in the raid role interface first before using this tool.",
        ["HealRangeExplain"] = "Make sure that green disks on the radar contain everyone in the raid.",

        ["InterruptBoss"] = "Interrupt the boss!",
        ["InterruptUnit"] = "Interrupt %s!",
        ["BombSelf"] = "You are a bomb!",
        ["BombOther"] = "%s is a bomb!",
        ["SpellAnnounce"] = "%s: %s",
        ["SpellIncomingAlert"] = "%s incoming!",
        ["SpellSelfAlert"] = "%s on you!",
        ["SpellOtherAlert"] = "%s on %s!",
        ["Interruption"] = "Interruption",
        ["InterruptChainSuccess"] = "Interrupt from %s successful!",
        ["InterruptChainFailed"] = "Interrupt failed!",
        ["InterruptChainNext"] = "%s is next to interrupt!",
        ["PhaseOne"]   = "Phase 1",
        ["PhaseTwo"]   = "Phase 2",
        ["PhaseThree"] = "Phase 3",
        ["PhaseFour"]  = "Phase 4",
        ["PhaseFive"]  = "Phase 5",
        ["NotImplementedBoss1"] = "This boss is not implemented yet.",
        ["NotImplementedBoss2"] = "Please check regularly for new versions.",

        ["SettingSpell"] = "Announce %s",
        ["SettingSpellSingleExplain"] = "Announce the player that gets %s.",
        ["SettingSpellSingleSymbolExplain"] = "Announce the player that gets %s and put the %s symbol.",
        ["SettingSpellMultipleExplain"] = "Announce the players that get %s.",
        ["SettingSpellMultipleSymbolExplain"] = "Announce the players that get %s and put symbols on them, starting with %s symbol.",
        ["SettingThreshold"] = "%s threshold",
        ["SettingThresholdExplain"] = "If you get the specified number of %s stacks, an alert will be shown.",
        ["SettingSpellSymbol"] = "Symbol: %s",
        ["SettingSpellSymbolSingleExplain"] = "Put the %s symbol on the player that gets %s.",
        ["SettingSpellSymbolMultipleExplain"] = "Put symbols on players that get %s, starting with %s symbol.",
        ["SettingHeroicOnly"] = " |cff00ffff(heroic only)|r",
        ["SettingHeroicOnlyExplain"] = "\n\n|cff00ffffThis setting only applies to heroic mode.|r",

        ["Suffix:LFRSize"] = " - LFR, %d",
        ["Suffix:HeroicSize"] = " - heroic, %d",
        ["Suffix:Heroic"] = " - heroic",
        ["Suffix:Size"] = " - %d",

        ["Version-QueryForbidden"] = "You can't do this yet. Please wait a few seconds.",
        ["Version-QueryStarted"] = "Querying versions... Please wait a few seconds.",
        ["Version-Results"] = "Version query results (%d):",
        ["Version-Unknown"] = "|cffff0000Unknown version|r",
        ["Version-Disconnected"] = "|cff808080Disconnected|r",
        ["Version-NoAnswer"] = "|cffffff00No answer|r",
        ["Version-Answer"] = "|cff00ff00BossEncounter3 v%s|r",
        ["Version-Self"] = "You are using version %s.",
        ["Version-Guild"] = "GUILD",
        ["Version-Group"] = "GROUP",

        ["Console-BadSyntax"] = "Bad syntax for this slash command. Try:\n",
        ["Console-Unknown"] = "You specified an unknown command. Suggestions:\n",
        ["Console-Broken"] = "|cffff0000The command could not be run, though it should have.|r",
        ["Console-Author"] = "Author: |cff00ff00MrCool|r.\nMain character: |cff00ff00Eilylune|r on |cff00ff00Drek'Thar|r server (Europe, FR).\nYou may contact me to provide bug reports.",
        ["Console-WipeAllData"] = "Are you sure you want to erase all BossEncounter3 saved data, including settings of widgets, modules and records? The AddOn will behave the same way it would if it was run for the first time.\n\nYour interface will be reloaded.",

        ["DamageMeter-Title"] = "********** Relevant DPS **********",
        ["DamageMeter-Entry"] = "%d) %s - %d%s (%.2f%%) || Superfluous: %d || Relevance: %d%%",
        ["DamageMeter-Pet"] = " [%d from pet]",
        ["DamageMeter-Average"] = "Average: %d",
        ["DamageGraph-Title"] = "Relevant DPS",
        ["DamageGraph-Entry"] = "%d) %d DPS%s (%.2f%%)\n\nSuperfluous: %d DPS\nRelevance: %d%%",

        ["Score-Title"] = "Performances",
        ["Score-Total"] = "Total",
        ["Score-Record"] = "Record",
        ["Score-Nice"] = "Nice!",
        ["Score-New"] = "New!",

        ["Summary-TotalDps"] = "Total DPS: %d",
        ["Summary-MyDps"] = "Your DPS: %d",
        ["Summary-Score"] = "Score: %d pts",
        ["Summary-NewRecord"] = "New record!",

        ["AutoReply-Header"] = "%s is currently in combat against the following boss: [%s]",
        ["AutoReply-Body"] = "Boss %s HP, combat time: %s",
        ["AutoReply-Tail"] = "%s players alive",

        ["EquipChecker-Title"] = "Equipment",
        ["EquipChecker-SelfEmpty"] = "It looks like you have forgotten to equip something.",
        ["EquipChecker-SelfBad"] = "You might have forgotten to swap an item in your equipment: %s.",
        ["EquipChecker-OtherEmpty"] = "%s: %d item slot(s) empty.",
        ["EquipChecker-OtherBad"] = "%s: %s detected.",
        ["EquipChecker-OtherSummary"] = "Check items equipped by: %s.",
        ["EquipChecker-Begin"] = "Start of inspection.",
        ["EquipChecker-End"] = "End of inspection.",
        ["EquipChecker-Warning"] = "Warning: %s couldn't be inspected.",
        ["EquipChecker-Incomplete"] = "Warning: inspection of %s is not complete.",
        ["EquipChecker-NoGroup"] = "You're not in a group.",

        ["Setting-ModuleTitle"] = "Module settings",
        ["Setting-GlobalTitle"] = "General settings",
        ["Setting-ModulePage"] = "Module settings",
        ["Setting-GlobalPage"] = "General settings",
        ["Setting-Lock"] = "\n\n|cffff0000You don't have the required rank to make use of this setting. Try getting a promote or it won't have any effect.|r",
        ["Setting-Exclusive"] = "\n\n|cff00ff00This setting can only be decided by one person at a time. The player with the most recent version and raid permissions will have priority.|r",
        ["Setting-PerCharacter"] = "\n\n|cff8080ffThis option is saved per character; you can choose other values for your other characters.|r",

        ["Plugin-Header"] = "Music plugins",
        ["Plugin-Page"] = "Plugin %d/%d",
        ["Plugin-Use"] = "Use",
        ["Plugin-Play"] = "Play",
        ["Plugin-Title"] = "Title",
        ["Plugin-Duration"] = "Length",
        ["Plugin-None"] = "You have installed no music plugin.\n\nCheck BE3 Curse page for a list of available music plugins.",
        ["Plugin-Author"] = "Compilation by %s",
        ["Plugin-Enable"] = "Enable",
        ["Plugin-Disable"] = "Disable",

        ["Difficulty:1"] = "|cff00ff00What do I do?|r",
        ["Difficulty:2"] = "|cff80ff00Show me the way.|r",
        ["Difficulty:3"] = "|cffffff00I am a normal player.|r",
        ["Difficulty:4"] = "|cffff8000Bring it on.|r",
        ["Difficulty:5"] = "|cffff0000I don't need any help!|r",

        ["Role:1"] = "Melee",
        ["Role:2"] = "Ranged",
        ["Role:3"] = "Healer",
        ["Role:4"] = "Tank",

        ["ErrorTitle"] = "***** Errors done by players *****",
        ["ErrorTotal"] = "Total of %d errors, %.2f per minute per player.",
        ["ErrorFatalTag"] = "Fatal{rt8}",
        ["Error:avoid-effect"] = "has taken an avoidable effect.",
        ["Error:avoid-interrupt"] = "has taken an avoidable interrupt.",
        ["Error:avoid-damage"] = "has taken avoidable damage.",
        ["Error:avoid-bomb"] = "has taken bomb damage.",
        ["Error:interrupt"] = "has missed an interrupt.",
        ["Error:aggro"] = "has aggro of the creature.",

        ["CriteriaShort:attempt"] = "Try",
        ["CriteriaShort:speed"] = "Spd",
        ["CriteriaShort:technique"] = "Skl",
        ["CriteriaFull:attempt"] = "Attempts",
        ["CriteriaFull:speed"] = "Speed",
        ["CriteriaFull:technique"] = "Skill",
        ["CriteriaHelp:attempt"] = "Higher score means you have needed less attempts to kill the boss.",
        ["CriteriaHelp:speed"] = "Higher score means the combat hasn't lasted long in the successful attempt.",
        ["CriteriaHelp:technique"] = "Higher score means the group has survived and has enough mana left at the end of the fight.",
    },

    ["frFR"] = {
        ["HP"] = "PV",
        ["Ad"] = "Fourni par BossEncounter3",
        ["Anchor"] = "Point d'ancrage",
        ["DefaultPosition"] = "Position par défaut",
        ["Lock"] = "Verrouiller la position",
        ["Size"] = "Redimensionner",
        ["Top"] = "Haut",
        ["Center"] = "Centre",
        ["Bottom"] = "Bas",

        ["BootComplete"] = "Chargé (v%s, %d plugins musicaux).\n/BE3 (ou /BE) pour accéder aux commandes slash.",
        ["FirstTimeNotice"] = "Vous avez lancé la version %s de BossEncounter3 pour la première fois.\n\nUtilisez |cff808080/BE3|r pour accéder aux commandes.\nVous devriez également examiner /BE3 options.\n\nVeuillez taper le mot en gris pour fermer cette fenêtre pop-up.",
        ["SaveReformat"] = "Des changements du système ont nécessité d'effacer les données sauvegardées.",
        ["NoAdminIgnore"] = "Vous ne pouvez pas ignorer un administrateur interne à BE3.",
        ["IncompleteFight"] = "Combat incomplet",
        ["IncompleteFightExplain"] = "Vous avez eu un |cffff0000\"combat incomplet\"|r. Ceci se produit quand le module de boss est activé après que le boss ait été engagé. Sélectionnez le boss avant d'engager le combat pour éviter cela.",
        ["CoupDeGrace"] = "Coup de grâce !",
        ["Try"] = "Essai %d",
        ["Failure"] = "Echec",
        ["Expiration"] = "Fermeture",
        ["Defeated"] = "[%s] a été vaincu en %d essai(s) !",
        ["FightTime"] = "Durée du combat : %s",
        ["TimeRecord"] = "Meilleur temps précédent : %s",
        ["NoSequenceReplay"] = "Pas de séquence de victoire à rejouer : vous n'avez vaincu aucun boss durant cette session de jeu.",
        ["NoDpsData"] = "Pas de données disponibles : vous n'avez vaincu aucun boss durant cette session de jeu.",
        ["NoActiveModule"] = "Aucun module n'est actif.",
        ["DifficultySet"] = "Niveau de difficulté fixé à [%s] (%d).",
        ["InvalidDifficulty"] = "Vous avez spécifié un niveau de difficulté invalide.",
        ["ThresholdShort"] = "%s bientôt.",
        ["ThresholdFull"] = "%s à %d%%.",
        ["TestAlert"] = "Alerte de test",
        ["TestMessage"] = "Message de test",
        ["TestEnabled"] = "Mode test activé. Retapez test pour désactiver le mode test.",
        ["TestDisabled"] = "Mode test désactivé.",
        ["CaptureSample"] = "Il y a %d échantillons pour le boss [%s].",
        ["HealRangeInvalid"] = "Veuillez indiquer les personnes qui ont le rôle de soigneur dans l'interface de raid avant d'utiliser cet outil.",
        ["HealRangeExplain"] = "Vérifiez sur le radar que toutes les personnes du raid se trouvent dans les disques verts.",

        ["InterruptBoss"] = "Interrompez le boss !",
        ["InterruptUnit"] = "Interrompez %s !",
        ["BombSelf"] = "Vous êtes une bombe !",
        ["BombOther"] = "%s est une bombe !",
        ["SpellAnnounce"] = "%s : %s",
        ["SpellIncomingAlert"] = "%s imminent !",
        ["SpellSelfAlert"] = "%s sur vous !",
        ["SpellOtherAlert"] = "%s sur %s !",
        ["Interruption"] = "Interruption",
        ["InterruptChainSuccess"] = "Interruption réussie par %s!",
        ["InterruptChainFailed"] = "Interruption échouée!",
        ["InterruptChainNext"] = "%s est le prochain à interrompre!",
        ["PhaseOne"]   = "Phase 1",
        ["PhaseTwo"]   = "Phase 2",
        ["PhaseThree"] = "Phase 3",
        ["PhaseFour"]  = "Phase 4",
        ["PhaseFive"]  = "Phase 5",
        ["NotImplementedBoss1"] = "Ce boss n'est pas encore implémenté.",
        ["NotImplementedBoss2"] = "Vérifiez si une nouvelle version est dispo.",

        ["SettingSpell"] = "Annoncer %s",
        ["SettingSpellSingleExplain"] = "Annonce le joueur subissant %s.",
        ["SettingSpellSingleSymbolExplain"] = "Annonce le joueur subissant %s et lui met le symbole %s.",
        ["SettingSpellMultipleExplain"] = "Annonce les joueurs subissant %s.",
        ["SettingSpellMultipleSymbolExplain"] = "Annonce les joueurs subissant %s et place des symboles sur eux, en commençant par %s.",
        ["SettingThreshold"] = "Seuil de %s",
        ["SettingThresholdExplain"] = "Si vous obtenez le nombre spécifié d'empilements de %s, une alerte sera affichée.",
        ["SettingSpellSymbol"] = "Symbole : %s",
        ["SettingSpellSymbolSingleExplain"] = "Place le symbole %s sur le joueur subissant %s.",
        ["SettingSpellSymbolMultipleExplain"] = "Place des symboles sur les joueurs subissant %s, en commençant par %s.",
        ["SettingHeroicOnly"] = " |cff00ffff(héroïque uniquement)|r",
        ["SettingHeroicOnlyExplain"] = "\n\n|cff00ffffCette option ne s'applique qu'au mode héroïque.|r",

        ["Suffix:LFRSize"] = " - outil raids, %d",
        ["Suffix:HeroicSize"] = " - héroïque, %d",
        ["Suffix:Heroic"] = " - héroïque",
        ["Suffix:Size"] = " - %d",

        ["Version-QueryForbidden"] = "Vous ne pouvez pas encore faire cela. Essayez de patienter un instant.",
        ["Version-QueryStarted"] = "Début de la requête de version... Veuillez patienter quelques secondes.",
        ["Version-Results"] = "Résultats de la requête de version (%d) :",
        ["Version-Unknown"] = "|cffff0000Version inconnue|r",
        ["Version-Disconnected"] = "|cff808080Déconnecté(e)|r",
        ["Version-NoAnswer"] = "|cffffff00Pas de réponse|r",
        ["Version-Answer"] = "|cff00ff00BossEncounter3 v%s|r",
        ["Version-Self"] = "Vous utilisez la version %s.",
        ["Version-Guild"] = "GUILDE",
        ["Version-Group"] = "GROUPE",

        ["Console-BadSyntax"] = "Mauvaise syntaxe pour cette commande slash. Essayez :\n",
        ["Console-Unknown"] = "Vous avez entré une commande inconnue. Suggestions :\n",
        ["Console-Broken"] = "|cffff0000La commande n'a pas pu être exécutée, alors qu'elle aurait dû.|r",
        ["Console-Author"] = "Auteur: |cff00ff00MrCool|r.\nPersonnage principal: |cff00ff00Eilylune|r sur le serveur |cff00ff00Drek'Thar|r (Europe, FR).\nIl est possible de me contacter pour des rapports de bugs.",
        ["Console-WipeAllData"] = "Êtes-vous sûr(e) de vouloir effacer toutes les données sauvegardées de BossEncounter3, incluant la configuration des gadgets, des modules et les records ? L'AddOn se comportera comme si elle était lancée pour la première fois.\n\nVotre interface sera rechargée.",

        ["DamageMeter-Title"] = "********** DPS pertinent **********",
        ["DamageMeter-Entry"] = "%d) %s - %d%s (%.2f%%) || Superflu : %d || Pertinence : %d%%",
        ["DamageMeter-Pet"] = " [%d du familier]",
        ["DamageMeter-Average"] = "Moyenne : %d",
        ["DamageGraph-Title"] = "DPS pertinent",
        ["DamageGraph-Entry"] = "%d) %d DPS%s (%.2f %%)\n\nSuperflu: %d DPS\nPertinence: %d%%",

        ["Score-Title"] = "Performances",
        ["Score-Total"] = "Total",
        ["Score-Record"] = "Record",
        ["Score-Nice"] = "Joli !",
        ["Score-New"] = "Nouveau !",

        ["Summary-TotalDps"] = "DPS total : %d",
        ["Summary-MyDps"] = "Votre DPS : %d",
        ["Summary-Score"] = "Score : %d pts",
        ["Summary-NewRecord"] = "Nouveau record !",

        ["AutoReply-Header"] = "%s est actuellement en combat contre le boss suivant: [%s]",
        ["AutoReply-Body"] = "Boss %s PV, temps de combat: %s",
        ["AutoReply-Tail"] = "%s joueurs en vie",

        ["EquipChecker-Title"] = "Equipement",
        ["EquipChecker-SelfEmpty"] = "On dirait que vous avez oublié d'équiper quelque chose.",
        ["EquipChecker-SelfBad"] = "Il semble que vous ayez oublié de changer d'objet : %s.",
        ["EquipChecker-OtherEmpty"] = "%s : %d emplacement(s) d'objet vide(s).",
        ["EquipChecker-OtherBad"] = "%s : %s détecté.",
        ["EquipChecker-OtherSummary"] = "Vérifiez les objets équipés par : %s.",
        ["EquipChecker-Begin"] = "Début de la vérification.",
        ["EquipChecker-End"] = "Vérification terminée.",
        ["EquipChecker-Warning"] = "Attention : %s n'a pas pu être inspecté.",
        ["EquipChecker-Incomplete"] = "Attention : l'inspection de %s est incomplète.",
        ["EquipChecker-NoGroup"] = "Vous n'êtes pas dans un groupe.",

        ["Setting-ModuleTitle"] = "Réglages du module",
        ["Setting-GlobalTitle"] = "Réglages généraux",
        ["Setting-ModulePage"] = "Réglages du module",
        ["Setting-GlobalPage"] = "Réglages généraux",
        ["Setting-Lock"] = "\n\n|cffff0000Vous n'avez pas le rang requis pour utiliser cette option. Essayez d'obtenir une promotion, sinon elle n'aura aucun effet.|r",
        ["Setting-Exclusive"] = "\n\n|cff00ff00Seule une personne à la fois peut décider de l'état de cette option. Le joueur avec la version la plus récente et les permissions requises aura priorité.|r",
        ["Setting-PerCharacter"] = "\n\n|cff8080ffCette option est sauvegardée par personnage; vous pouvez choisir d'autres valeurs pour vos autres personnages.|r",

        ["Plugin-Header"] = "Plugins musicaux",
        ["Plugin-Page"] = "Plugin %d/%d",
        ["Plugin-Use"] = "Actif",
        ["Plugin-Play"] = "Jouer",
        ["Plugin-Title"] = "Titre",
        ["Plugin-Duration"] = "Durée",
        ["Plugin-None"] = "Vous n'avez installé aucun plugin musical.\n\nLa page Curse de BE3 contient une liste de plugins disponibles.",
        ["Plugin-Author"] = "Compilation par %s",
        ["Plugin-Enable"] = "Activer",
        ["Plugin-Disable"] = "Désactiver",

        ["Difficulty:1"] = "|cff00ff00Que dois-je faire ?|r",
        ["Difficulty:2"] = "|cff80ff00Montre-moi le chemin.|r",
        ["Difficulty:3"] = "|cffffff00Je suis un joueur normal.|r",
        ["Difficulty:4"] = "|cffff8000Autonome ? Je le suis.|r",
        ["Difficulty:5"] = "|cffff0000J'ai besoin d'aucune aide !|r",

        ["Role:1"] = "Mêlée",
        ["Role:2"] = "Distance",
        ["Role:3"] = "Soigneur",
        ["Role:4"] = "Tank",

        ["ErrorTitle"] = "***** Erreurs des joueurs *****",
        ["ErrorTotal"] = "Total de %d erreurs, %.2f par minute par joueur.",
        ["ErrorFatalTag"] = "Fatal{rt8}",
        ["Error:avoid-effect"] = "a pris un effet évitable.",
        ["Error:avoid-interrupt"] = "a subi une interruption évitable.",
        ["Error:avoid-damage"] = "a subi des dégâts évitables.",
        ["Error:avoid-bomb"] = "a subi des dégâts d'une bombe.",
        ["Error:interrupt"] = "a raté une interruption.",
        ["Error:aggro"] = "a pris l'aggro sur la créature.",

        ["CriteriaShort:attempt"] = "Ess",
        ["CriteriaShort:speed"] = "Vit",
        ["CriteriaShort:technique"] = "Tal",
        ["CriteriaFull:attempt"] = "Essais",
        ["CriteriaFull:speed"] = "Vitesse",
        ["CriteriaFull:technique"] = "Talent",
        ["CriteriaHelp:attempt"] = "Des points élevés signifient que vous avez eu besoin de peu d'essais pour vaincre le boss.",
        ["CriteriaHelp:speed"] = "Des points élevés signifient que le combat n'a pas duré longtemps lors de l'essai fructueux.",
        ["CriteriaHelp:technique"] = "Des points élevés signifient que la plupart des joueurs ont survécu avec une bonne quantité de mana restante à la fin du combat.",
    },
};

-- --------------------------------------------------------------------
-- **                             Methods                            **
-- --------------------------------------------------------------------

function Localization:GetLocale(critical)
    local locale = GetLocale();
    if (not critical) and overrideLocale then
        locale = overrideLocale;
    end
    return redirection[locale] or locale;
end

function Localization:GetDefaultLocale()
    return "enUS";
end

function Localization:Translate(key)
    local t = locale[self:GetLocale(false)];
    if not t then t = locale[self:GetDefaultLocale()]; end

    if t and t[key] then
        return t[key];
  else
        return (MISSING_TRANSLATION):format(key);
    end
end

function Localization:FormatLoc(key, ...)
    local str = self:Translate(key);
    return str:format(...);
end

function Localization:ReadTable(table)
    if table then
        if type(table) == "string" then
            return table;
      else
            return table[self:GetLocale()] or table[self:GetDefaultLocale()];
        end
  else
        return nil;
    end
end

Localization.Get = Localization.Translate;
Localization.FormatGet = Localization.FormatLoc;
Localization.FormatTranslate = Localization.FormatLoc;