local Root = BossEncounter3;

local Resources = Root:GetOrNewModule("Resources");

local L = Root:GetOrNewModule("Localization");
local Table = Root:GetOrNewModule("Table");
local Save = Root:GetOrNewModule("Save");

-- --------------------------------------------------------------------
-- **                               Data                             **
-- --------------------------------------------------------------------

Resources.list = { };

Resources.plugins = { };

Resources.musics = { };

local CORE_MUSICS = {
    {
        name = "SILENCE",
        file = "Silence.mp3",
        category = "SILENCE",
        duration = 5.067,
        importance = 100,
    },
    {
        name = "VICTORY_GREAT",
        file = "Fanfare_I.mp3",
        type = "VICTORY",
        duration = 45.740,
        importance = 100,
    },
    {
        name = "VICTORY_GOOD",
        file = "Fanfare_II.mp3",
        category = "VICTORY",
        duration = 45.217,
        importance = 100,
    },
    {
        name = "VICTORY_FAIR",
        file = "Fanfare_III.mp3",
        category = "VICTORY",
        duration = 49.554,
        importance = 100,
    },
    {
        name = "VICTORY_EXCELLENT",
        file = "Fanfare_X.mp3",
        category = "VICTORY",
        duration = 45.139,
        importance = 100,
    },
    {
        name = "JINGLE",
        file = "Jingle.mp3",
        category = "VICTORY",
        duration = 7.5,
        importance = 100,
    },
    {
        name = "FIRSTTRY",
        file = "FirstTry.mp3",
        category = "FIRST",
        duration = 8.25,
        importance = 100,
    },
};

Resources.textures = {
    {
        name = "EVENTS",
        filename = "events",
        available = { ["enUS"] = true, },
        width = 256,
        height = 32,
    },

    {
        name = "ENEMIES",
        filename = "enemies",
        available = { ["enUS"] = true, },
        width = 256,
        height = 32,
    },

    -- Band graphics

    {
        name = "BAND_HN",
        filename = "horizontalBandNormal",
        width = 256,
        height = 32,
    },

    {
        name = "BAND_HS",
        filename = "horizontalBandSkew",
        width = 256,
        height = 32,
    },

    -- Bar graphics

    {
        name = "BAR_BORDER",
        filename = "barBorder",
        width = 256,
        height = 16,
    },

    {
        name = "BAR_INSIDE",
        filename = "barInside",
        width = 256,
        height = 16,
    },

    {
        name = "BAR_FILL",
        filename = "barFill",
        width = 256,
        height = 16,
    },

    {
        name = "SIMPLEBAR_INSIDE",
        filename = "simpleBarInside",
        width = 256,
        height = 16,
    },

    {
        name = "SIMPLEBAR_FILL",
        filename = "simpleBarFill",
        width = 256,
        height = 16,
    },

    {
        name = "BOSSBAR_BORDER",
        filename = "bossBarBorder",
        width = 512,
        height = 32,
    },

    {
        name = "BOSSBAR_INSIDE",
        filename = "bossBarInside",
        width = 512,
        height = 32,
    },

    {
        name = "BOSSBAR_FILL",
        filename = "bossBarFill",
        width = 16,
        height = 16,
    },

    {
        name = "BOSSBAR_FILLVARIATION",
        filename = "bossBarFillVariation",
        width = 16,
        height = 16,
    },

    {
        name = "BOSSBAR_FILLSPECIAL",
        filename = "bossBarFillSpecial",
        width = 16,
        height = 16,
    },

    {
        name = "BOSSBAR_TOKEN",
        filename = "bossBarToken",
        width = 32,
        height = 4,
    },

    {
        name = "BOSSBAR_TOKENSPECIAL",
        filename = "bossBarTokenSpecial",
        width = 32,
        height = 4,
    },

    -- Radar graphics

    {
        name = "RADAR_ARROW",
        filename = "radarArrow",
        width = 32,
        height = 32,
    },

    {
        name = "RADAR_PIN",
        filename = "radarPin",
        width = 8,
        height = 8,
    },

    {
        name = "RADAR_DANGER",
        filename = "radarDanger",
        width = 8,
        height = 8,
    },

    {
        name = "RADAR_ZONE",
        filename = "radarZone",
        width = 64,
        height = 64,
    },

    {
        name = "RADAR_INSIDE",
        filename = "radarInside",
        width = 256,
        height = 256,
    },

    {
        name = "RADAR_BORDER",
        filename = "radarBorder",
        width = 256,
        height = 256,
    },

    -- Misc graphics

    {
        name = "CLOCK",
        filename = "clock",
        width = 64,
        height = 64,
    },

    {
        name = "WARNING",
        filename = "warning",
        width = 64,
        height = 64,
    },

    {
        name = "WARNING_BACKGROUND",
        filename = "warningBackground",
        width = 512,
        height = 512,
    },

    {
        name = "CLEARED",
        filename = "cleared",
        width = 512,
        height = 128,
    },

    {
        name = "FLASH",
        filename = "flash",
        width = 512,
        height = 512,
    },

    {
        name = "SEPARATOR",
        filename = "separator",
        width = 256,
        height = 8,
    },

    {
        name = "KILLING_BLOW",
        filename = "killingBlow",
        width = 64,
        height = 8,
    },

    {
        name = "WRENCH",
        filename = "wrench",
        width = 32,
        height = 32,
    },

    {
        name = "THRESHOLD",
        filename = "threshold",
        width = 8,
        height = 32,
    },

    {
        name = "SWEEP",
        filename = "sweep",
        width = 64,
        height = 16,
    },
};

Resources.fonts = {
    {
        name = "CYBERSPACE",
        filename = "cyberspace",
        imageWidth = 256,
        imageHeight = 128,
        charWidth = 24,
        charHeight = 18,
        charPerLine = 10,
        charPerColumn = 4,
        map = { "ABCDEFGHIJKLMNOPQRSTUVWXYZ?!./0123456789:[]()=+-*'",
                "abcdefghijklmnopqrstuvwxyz?!./0123456789:[]()=+-*'" }, -- Indifferent to capital letters.
    },
};

Resources.sounds = {
    {
        name = "FAIL1",
        filename = "fail1.mp3",
        type = "FAIL",
    },
    {
        name = "FAIL2",
        filename = "fail2.mp3",
        type = "FAIL",
    },
    {
        name = "SWIFTFAIL",
        filename = "failStandard.mp3",
        type = "SWIFTFAIL",
    },
    {
        name = "BIGFAIL",
        filename = "failDisappointing.mp3",
        type = "BIGFAIL",
    },
    {
        name = "EXPIRATION",
        filename = "expiration.mp3",
        type = "EXPIRATION",
    },
    {
        name = "GREATPERFORMANCE",
        filename = "greatPerformance.mp3",
        type = "GREATPERFORMANCE",
    },
    {
        name = "LASTSECONDS",
        filename = "lastSeconds.mp3",
        type = "LASTSECONDS",
    },
    {
        name = "NEWRECORD",
        filename = "newRecord.mp3",
        type = "NEWRECORD",
    },
    {
        name = "NONEWRECORD",
        filename = "noNewRecord.mp3",
        type = "NONEWRECORD",
    },
    {
        name = "NICE",
        filename = "nice.mp3",
        type = "NICE",
    },
    {
        name = "STARTTIMER",
        filename = "startTimer.mp3",
        type = "STARTTIMER",
    },
    {
        name = "WOOSH",
        filename = "woosh.mp3",
        type = "WOOSH",
    },

    {
        name = "CLEARED1",
        filename = "cleared1.mp3",
        type = "CLEARED",
    },
    {
        name = "CLEARED2",
        filename = "cleared2.mp3",
        type = "CLEARED",
    },
    {
        name = "COUPDEGRACE",
        filename = "coupDeGrace.mp3",
        type = "CLEARED",
    },
    {
        name = "PHASECHANGE",
        filename = "phaseChange.mp3",
        type = "PHASECHANGE",
    },
    {
        name = "TIMETICK",
        filename = "timeTick.mp3",
        type = "TIMETICK",
    },
    {
        name = "TRIGGER",
        filename = "trigger.mp3",
        type = "TRIGGER",
    },
    {
        name = "BLINK",
        filename = "blink.mp3",
        type = "BLINK",
    },
    {
        name = "BLINKCRITICAL",
        filename = "blinkCritical.mp3",
        type = "BLINK",
    },
    {
        name = "ALERT",
        filename = "alert.mp3",
        type = "ALERT",
    },
    {
        name = "HIT",
        filename = "hit.mp3",
        type = "HIT",
    },
    {
        name = "NOTIFY",
        filename = "notify.mp3",
        type = "NOTIFY",
    },
    {
        name = "POPUP",
        filename = "popup.mp3",
        type = "POPUP",
    },
};

-- --------------------------------------------------------------------
-- **                             Methods                            **
-- --------------------------------------------------------------------

-- ---------------
-- Texture methods
-- ---------------

function Resources:BuildTextureFilename(filename, isLocalized, availableLocales)
    if isLocalized and availableLocales then
        local locale = L:GetLocale();
        if not availableLocales[locale] then
            locale = L:GetDefaultLocale();
        end
        return Root:GetFolder().."gfx\\localized\\"..filename.."-"..locale;
  else
        return Root:GetFolder().."gfx\\"..filename;
    end
end

function Resources:GetNumTextures()
    return #self.textures;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index or name: index or internal name of texture.                *
-- ********************************************************************
-- * Return info about a certain texture (selected for your language) *
-- * - Internal name (you ought to work with this, instead of index)  *
-- * - Filename (leading to the appropriate localized graphic)        *
-- * - Width, height of the texture                                   *
-- ********************************************************************
function Resources:GetTextureInfo(query)
    if type(query) == 'string' then
        local i, name, filename, width, height;
        for i=1, self:GetNumTextures() do
            name, filename, width, height = self:GetTextureInfo(i);
            if name == query then
                return name, filename, width, height;
            end
        end
  else
        local info = self.textures[query];
        if info then
            return info.name, self:BuildTextureFilename(info.filename, info.available ~= nil, info.available), info.width, info.height;
        end
    end
    return nil, nil, 0, 0;
end

-- ------------
-- Font methods
-- ------------

function Resources:BuildFontFilename(filename)
    return Root:GetFolder().."gfx\\font\\"..filename;
end

function Resources:GetNumFonts()
    return #self.fonts;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index or name: index or internal name of font.                   *
-- ********************************************************************
-- * Return info about a certain font:                                *
-- * - Internal name (you ought to work with this, instead of index)  *
-- * - Filename (leading to the appropriate font file)                *
-- * - Is graphic (always true for now, means the font is an image)   *
-- *                                                                  *
-- * If "Is graphic" is true, the following are also returned:        *
-- * - Width, height of the image                                     *
-- * - Width, height of a char within the image                       *
-- * - perLine, perColumn: numbers of chars per line or column        *
-- * - map: specifies what graphic should be displayed for each char. *
-- ********************************************************************
function Resources:GetFontInfo(query)
    if type(query) == 'string' then
        local i, name, filename, isGraphic, imgWidth, imgHeight, charWidth, charHeight, charPerLine, charPerColumn, charMap;
        for i=1, self:GetNumFonts() do
            name, filename, isGraphic, imgWidth, imgHeight, charWidth, charHeight, charPerLine, charPerColumn, charMap = self:GetFontInfo(i);
            if name == query then
                return name, filename, isGraphic, imgWidth, imgHeight, charWidth, charHeight, charPerLine, charPerColumn, charMap;
            end
        end
  else
        local info = self.fonts[query];
        if info then
            return info.name, self:BuildFontFilename(info.filename), true, info.imageWidth, info.imageHeight, info.charWidth, info.charHeight, info.charPerLine, info.charPerColumn, info.matrix;
        end
    end
    return nil, nil, true, 0, 0, 0, 0, 0, 0, nil;
end

-- ********************************************************************
-- * Internal method done at initialization time.                     *
-- ********************************************************************
function Resources:GenerateFontMatrix(index)
    local font = self.fonts[index];
    if font then
        local map = font.map;
        if map then
            local matrix = { };
            local i, j, x, y, str, char;
            for i=1, #map do
                x, y = 0, 0;
                str = map[i];

                for j=1, #str do
                    char = str:sub(j, j);
                    matrix[char] = {x, y};

                    x = x + 1;
                    if x >= font.charPerLine then
                        x = 0;
                        y = y + 1;
                    end
                end
            end
            font.matrix = matrix;
        end
    end
end

-- -------------
-- Music methods
-- -------------

function Resources:BuildMusicFilename(filename)
    return Root:GetFolder().."bgm\\"..filename;
end

function Resources:GetNumMusics()
    return #self.musics;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index or name: index or internal name of music.                  *
-- ********************************************************************
-- * Return info about a certain music:                               *
-- * - Name                                                           *
-- * - Filename                                                       *
-- * - Category                                                       *
-- * - Duration                                                       *
-- * - Importance                                                     *
-- * - Visible (true if the music can be seen in the music viewer)    *
-- ********************************************************************
function Resources:GetMusicInfo(query)
    if type(query) == 'string' then
        local i, name, filename, category, duration, importance, visible;
        for i=1, self:GetNumMusics() do
            name, filename, category, duration, importance, visible = self:GetMusicInfo(i);
            if name == query then
                return name, filename, category, duration, importance, visible;
            end
        end
  else
        local info = self.musics[query];
        if info then
            return info.name, info.file, info.category, info.duration, info.importance, (info.category == "BATTLE");
        end
    end
    return nil, nil, nil, 0, 0, false;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * type: type of music we'd like to get a list of.                  *
-- ********************************************************************
-- * Build a list of musics matching the specified type.              *
-- ********************************************************************
function Resources:ListMusicType(type)
    self:ClearList();
    local i, name, filename, category, duration;
    for i=1, self:GetNumMusics() do
        name, filename, category, duration = self:GetMusicInfo(i);
        if category == type then
            self:AddListEntry(name);
        end
    end
end

-- ********************************************************************
-- * Rebuild the list of available musics with only the core musics.  *
-- ********************************************************************
function Resources:RebuildCoreMusicList()
    self.musics = Table:Copy(CORE_MUSICS);

    -- Set the path
    local i, info;
    for i=1, #self.musics do
        info = self.musics[i];
        info.file = self:BuildMusicFilename(info.file);
    end
end

-- -------------
-- Sound methods
-- -------------

function Resources:BuildSoundFilename(filename)
    return Root:GetFolder().."sfx\\"..filename;
end

function Resources:GetNumSounds()
    return #self.sounds;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index or name: index or internal name of sound.                  *
-- ********************************************************************
-- * Return info about a certain sound:                               *
-- * - Internal name (you ought to work with this, instead of index)  *
-- * - Filename (leading to the sound, the root is SFX folder)        *
-- * - Type (the type of the sound, which explains when it is to be   *
-- *         used; if the game engine searches for this type of sound *
-- *         and there are more than one, it chooses randomly one.)   *
-- ********************************************************************
function Resources:GetSoundInfo(query)
    if type(query) == 'string' then
        local i, name, filename, myType;
        for i=1, self:GetNumSounds() do
            name, filename, myType = self:GetSoundInfo(i);
            if name == query then
                return name, filename, myType;
            end
        end
  else
        local info = self.sounds[query];
        if info then
            return info.name, self:BuildSoundFilename(info.filename), info.type;
        end
    end
    return nil, nil, nil;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * type: type of sound we'd like to get a list of.                  *
-- ********************************************************************
-- * Build a list of sounds matching the specified type.              *
-- ********************************************************************
function Resources:ListSoundType(type)
    self:ClearList();
    local i, name, filename, myType;
    for i=1, self:GetNumSounds() do
        name, filename, myType = self:GetSoundInfo(i);
        if myType == type then
            self:AddListEntry(name);
        end
    end
end

-- ------------
-- List methods
-- ------------

function Resources:ClearList()
    wipe(self.list);
end

function Resources:AddListEntry(obj)
    tinsert(self.list, obj);
end

function Resources:GetListSize()
    return #self.list;
end

function Resources:GetListEntry(index)
    return self.list[index];
end

function Resources:GetListRandomEntry()
    local size = self:GetListSize();
    if size == 0 then
        return nil;
  else
        return self.list[ math.random(1, size) ];
    end
end

-- --------------------
-- Music plugin methods
-- --------------------

function Resources:GetNumPlugins()
    return #self.plugins;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index: index of plugin.                                          *
-- ********************************************************************
-- * Return info about a plugin.                                      *
-- * - Name                                                           *
-- * - Author                                                         *
-- * - Number of musics                                               *
-- ********************************************************************
function Resources:GetPluginInfo(index)
    local info = self.plugins[index];
    if info then
        return info.name, info.author, #info.musics;
    end
    return nil, nil, 0;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index: index of plugin.                                          *
-- * music: index of the music.                                       *
-- ********************************************************************
-- * Return info about a plugin's music.                              *
-- * - Name                                                           *
-- * - File                                                           *
-- * - Category                                                       *
-- * - Duration                                                       *
-- * - Importance                                                     *
-- * - Enabled                                                        *
-- ********************************************************************
function Resources:GetPluginMusic(index, music)
    local info = self.plugins[index];
    if info then
        local disabled = Save:Get("plugin", info.name);
        local m = info.musics[music];
        if m then
            return m.name, m.file, m.category, m.duration, m.importance, not disabled or not disabled[music];
        end
    end
    return nil, nil, nil, 0, 0, false;
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * index: index of plugin.                                          *
-- * music: index of the music.                                       *
-- * enabled: whether to enable the music or not.                     *
-- ********************************************************************
-- * Set whether to enable a specific music or not.                   *
-- ********************************************************************
function Resources:SetPluginMusicState(index, music, enabled)
    local info = self.plugins[index];
    if info then
        local disabled = Save:Get("plugin", info.name) or { };
        disabled[music] = (not enabled);
        Save:Set("plugin", info.name, disabled);

        self:RefreshPlugins();
    end
end

-- ********************************************************************
-- * Arguments:                                                       *
-- * info: data table of the plugin.                                  *
-- ********************************************************************
-- * Register a music plugin.                                         *
-- ********************************************************************
function Resources:RegisterPlugin(info)
    local musics = info.musics;
    assert(musics);
    tinsert(self.plugins, {name = info.name or UNKNOWN,
                           author = info.author or UNKNOWN,
                           musics = musics} );
    -- Set path
    local i, music;
    for i=1, #musics do
        music = musics[i];
        music.file = info.folder..music.file;
    end
end

-- ********************************************************************
-- * Iterate on all plugins and add enabled musics.                   *
-- ********************************************************************
function Resources:RefreshPlugins()
    self:RebuildCoreMusicList();

    local i, info, musics, disabled, j;
    for i=1, #self.plugins do
        info = self.plugins[i];
        musics = info.musics;
        disabled = Save:Get("plugin", info.name);

        for j=1, #musics do
            if not disabled or not disabled[j] then
                tinsert(self.musics, musics[j]);
            end
        end
    end
end

-- --------------
-- Initialization
-- --------------

do
    local i;
    for i=1, Resources:GetNumFonts() do
        Resources:GenerateFontMatrix(i);
    end
end